static int command_fd;
static int data_fd;
static char *command_s;
static char *data_s;

static void init_songs(void)
{
  int fd;
  command_s = getenv("SONGS_COMMAND");
  data_s = getenv("SONGS_DATA");
  if (command_s == NULL && data_s == NULL) return;
  if (command_s == NULL || data_s == NULL) R;
  has_songs = 1;
  fd = open(command_s, O_RDWR);
  if (fd == -1) R;
  command_fd = open(command_s, O_WRONLY);
  if (command_fd == -1) R;
  close(fd);
}

static float bsb[1024];
static int bsb_pos;

static void start_songs(void)
{
  if (write(command_fd, "p", 1) != 1) R;
  data_fd = open(data_s, O_RDONLY); if (data_fd == -1) R;
  bsb_pos = 1024;
}

static void stop_songs(void)
{
  if (write(command_fd, "s", 1) != 1) R;
  if (close(data_fd)) R;
}

static void new_track_songs(char *t)
{
  if (write(command_fd, "n", 1) != 1) R;
  if (write(command_fd, t, strlen(t)) != strlen(t)) R;
  if (write(command_fd, "\n", 1) != 1) R;
}

static void buffer_songs(float *f)
{
  if (bsb_pos == 1024) {
    if (read(data_fd, bsb, 1024*4) != 1024*4) R;
    bsb_pos = 0;
  }
  memcpy(f, bsb + bsb_pos, SAMPLES * 4);
  bsb_pos += SAMPLES;
}
